﻿using Gifitti.Models;
using Gifitti.Transformation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Gifitti.View_Models
{
    public partial class SaveAsXbyYPrompt : Form
    {
        GifModel gm;
        int orignalWidth = 0;
        int originalHeight = 0;
        int width = 0;
        int height = 0;

        public SaveAsXbyYPrompt(int width, int height, GifModel gm)
        {
            InitializeComponent();
            orignalWidth = width;
            originalHeight = height;
            this.width = orignalWidth;
            this.height = originalHeight;
            WidthTextBox.Text = this.width.ToString();
            HeightTextBox.Text = this.height.ToString();
            this.gm = gm; //make this a clone 
        }

        private void SaveAsButtonClick(object sender, EventArgs e)
        {
            TransformGif.resizeGif(gm, width, height);
            String path = null;
            saveGifFileDialog.Filter = "GIF Files|*.gif";
            if (saveGifFileDialog.ShowDialog() == DialogResult.OK)
                path = saveGifFileDialog.FileName;

            //Handel Close
            if (path == null)
                return;
            //TODO temp write
            Console.WriteLine(path);
            try
            {
                gm.saveGif(path);
            }
            catch (DirectoryNotFoundException)
            {
                MessageBox.Show("Save Path Invalid!");
            }
            TransformGif.resizeGif(gm, orignalWidth, originalHeight);
            this.Close();
        }

        private void widthChanged(object sender, EventArgs e)
        {
            int w = 0;
            if (int.TryParse(WidthTextBox.Text, out w) & w >= 0){
                width = w;
            }
        }

        private void heightChanged(object sender, EventArgs e)
        {
            int h = 0;
            if (int.TryParse(HeightTextBox.Text,out h) & h >= 0)
            {
                height = h;
            }
        }
    }
}
